Undefined Behavior in GCC 4.8 ios_base.h

Bug #1514309 reported by Jeffrey Walton on 2015-11-09
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
gcc
Fix Released
Medium
gcc-4.8 (Ubuntu)
Medium
Unassigned
Trusty
Medium
Unassigned
gcc-5 (Debian)
Fix Released
Unknown
gcc-5 (Ubuntu)
Medium
Unassigned

Bug Description

On Linux, the distros often use libstdc++ rather than libc++ for Clang. Building libcxx is an art that I have never been able to untangle, and I think the maintainers have discovered the same.

Below, I'm catching a UB finding when using Clang and libstdc++. This one has been around for some time. I first encountered it on Apple platforms. I regularly encounter it on Debian and Ubuntu.

The fix is fairly easy, and I usually just do it: a couple of casts among unsigned and the flags. Also see http://lists.llvm.org/pipermail/cfe-dev/2015-January/040753.html.

**********

$ cat ub.cxx
#include <iostream>

int main(int argc, char* argv[])
{
  std::cout << std::hex << argc << std::endl;
  std::cout << std::dec << argc << std::endl;
  return 0;
}

$ clang++ -fsanitize=undefined ub.cxx -o ub.exe

$ ./ub.exe
/usr/lib/gcc/x86_64-linux-gnu/4.8/../../../../include/c++/4.8/bits/ios_base.h:96:24: runtime error: load of value 4294967221, which is not a valid value for type 'std::_Ios_Fmtflags'
/usr/lib/gcc/x86_64-linux-gnu/4.8/../../../../include/c++/4.8/bits/ios_base.h:76:67: runtime error: load of value 4294967221, which is not a valid value for type 'std::_Ios_Fmtflags'
1
1

**********

$ g++ --version
g++ (Ubuntu 4.8.4-2ubuntu1~14.04) 4.8.4

$ uname -a
Linux ubuntu 3.13.0-66-generic #108-Ubuntu SMP Wed Oct 7 15:20:27 UTC 2015 x86_64 x86_64 x86_64 GNU/Linux

$ lsb_release
No LSB modules are available.

**********

$ apt-cache show g++
Package: g++
Priority: optional
Section: devel
Installed-Size: 34
Maintainer: Ubuntu Developers <email address hidden>
Original-Maintainer: Debian GCC Maintainers <email address hidden>
Architecture: amd64
Source: gcc-defaults (1.124ubuntu6)
Version: 4:4.8.2-1ubuntu6
Provides: c++-compiler
Depends: cpp (>= 4:4.8.2-1ubuntu6), gcc (>= 4:4.8.2-1ubuntu6), g++-4.8 (>= 4.8.2-5~), gcc-4.8 (>= 4.8.2-5~)
Suggests: g++-multilib
Filename: pool/main/g/gcc-defaults/g++_4.8.2-1ubuntu6_amd64.deb
Size: 1490
MD5sum: 7332a4e9116b821e167a3d0236ca413a
SHA1: 2c7201808be1029d21b7691c5a855535a4fcbd51
SHA256: 02c3d204efe6c34bf3de655aaf6a9ce524511977aedf92d7bce7093d0581f977
Description-en: GNU C++ compiler
 This is the GNU C++ compiler, a fairly portable optimizing compiler for C++.
 .
 This is a dependency package providing the default GNU C++ compiler.
Description-md5: 4d44b18774ae5123b7c3f70d940cf655
Bugs: https://bugs.launchpad.net/ubuntu/+filebug
Build-Essential: yes
Origin: Ubuntu
Supported: 5y

Matthias Klose (doko) on 2015-11-18
affects: gcc-defaults (Ubuntu) → gcc-4.8 (Ubuntu)
Changed in gcc-4.8 (Ubuntu):
status: New → Confirmed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gcc-4.8 - 4.8.5-2ubuntu1

---------------
gcc-4.8 (4.8.5-2ubuntu1) xenial; urgency=medium

  * Merge with Debian; remaining changes:
    - Build from the upstream source.

gcc-4.8 (4.8.5-2) unstable; urgency=medium

  * Update the Linaro support to the 4.8-2015.07 release.
  * Adjust setting DH_COMPAT for dh_movefiles with updated debhelper supporting
    globbing of arguments. Closes: #800248.
  * Fix PR libstdc++/56158, taken from the trunk.
    Addresses: #804521. LP: #1514309.
  * Backport fixes to allow building with cloog-0.18.4 and isl-0.15.
  * Backport PR target/67281 from the trunk (HTM fixes). LP: #1517093.
  * Fix auto-loading of gdb pretty printers. LP: #1446828.

 -- Matthias Klose <email address hidden> Wed, 18 Nov 2015 19:57:42 +0100

Changed in gcc-4.8 (Ubuntu):
status: Confirmed → Fix Released

Hello Jeffrey, or anyone else affected,

Accepted gcc-4.8 into trusty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/gcc-4.8/4.8.4-2ubuntu1~14.04.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in gcc-4.8 (Ubuntu Trusty):
status: New → Fix Committed
tags: added: verification-needed
Changed in gcc-4.8 (Ubuntu):
importance: Undecided → Medium
Changed in gcc-4.8 (Ubuntu Trusty):
importance: Undecided → Medium
Mathew Hodson (mathew-hodson) wrote :
no longer affects: gcc-5 (Ubuntu Trusty)
Changed in gcc-5 (Ubuntu):
importance: Undecided → Medium
status: New → Fix Released
Changed in gcc-5 (Debian):
status: Unknown → Fix Released
Matthias Klose (doko) wrote :

verified that the proposed libstdc++-4.8-dev, when used with clang, doesn't show this runtime error.

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gcc-4.8 - 4.8.4-2ubuntu1~14.04.1

---------------
gcc-4.8 (4.8.4-2ubuntu1~14.04.1) trusty-proposed; urgency=medium

  * SRU:
  * Fix auto-loading of gdb pretty printers. LP: #1446828.
  * Fix PR libstdc++/56158, taken from the trunk.
    Addresses: #804521. LP: #1514309.
  * Backport PR target/64579 and PR target/67281 from the trunk (HTM fixes).
    LP: #1517093.

 -- Matthias Klose <email address hidden> Wed, 18 Nov 2015 17:48:36 +0100

Changed in gcc-4.8 (Ubuntu Trusty):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for gcc-4.8 has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Changed in gcc:
importance: Unknown → Medium
status: Unknown → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.